unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls,
  Windows,
  StdCtrls;


type
  TMouseEvent = (meMouseDown, meMouseUp);

  { TForm1 }

  TForm1 = class(TForm)
    Memo1: TMemo;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure ListView1Data(Sender: TObject; Item: TListItem);
    procedure ListView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ListView1KeyUp(Sender: TObject; var Key: Word; Shift: TShiftState
      );
    procedure ListView1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListView1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
   private
     procedure ReportIt(func: String; Key: Word; Shift: TShiftState);
     procedure ReportItMouse(MouseEvent: TMouseEvent);
   public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  ListView1.Items.Count := 10;
end;

procedure TForm1.ListView1Data(Sender: TObject; Item: TListItem);
begin
  Item.Caption := 'capt_' + IntToStr(Item.Index);;
  Item.SubItems.Add('sub1');
  Item.SubItems.Add('sub2');
end;

procedure TForm1.ListView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
     ReportIt('--KeyDown--', Key, Shift);
end;

procedure TForm1.ListView1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var  bIsNil: Boolean; S: String;
begin
  ReportIt('--KeyUp--', Key, Shift);
end;

procedure TForm1.ListView1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//  if Button = mbLeft then
//     ReportItMouse(meMouseDown);
end;

procedure TForm1.ListView1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
//  if Button = mbLeft then
//     ReportItMouse(meMouseUp);
end;

procedure TForm1.ReportIt(func: String; Key: Word; Shift: TShiftState);
var  bSelectedIsNil: Boolean; S: String; i: Integer;
begin
  if not (Key in [VK_UP, VK_DOWN])then exit;
  bSelectedIsNil := (ListView1.Selected = nil);
  if (Key = VK_UP) then S := 'VK_UP  ' + func else S := 'VK_DOWN  ' + func;
  if (Shift = [ssShift]) then S := S + ' with Shift';

  if Not bSelectedIsNil then
           Memo1.Lines.Add(S + '    OK:  as ListView Selected is not Nil.    //  "Selected" is set to: : ' +  ListView1.Selected.Caption)
      else Memo1.Lines.Add(S + '    WRONG!  ListView Seleccted is told to be Nil');

  if bSelectedIsNil then
     if ListView1.Focused then begin
        if ListView1.ItemFocused.Selected then  // potentially useful
           Memo1.Lines.Add('ListView.ItemFocused is Selected: ' + ListView1.ItemFocused.Caption  + ' .... --> candidate of interest')
        else   // simply ignore
           Memo1.Lines.Add('ListView.ItemFocused (is not Selected; no interest here) ' + ListView1.ItemFocused.Caption);
     end;

  with ListView1 do
       for i:= 0 to Items.Count - 1 do
           if  Items[i].Selected then
              Memo1.Lines.Add('     ... Item.Selected is true for: ' + items[i].Caption);

  Memo1.Lines.Add('');
end;

procedure TForm1.ReportItMouse(MouseEvent: TMouseEvent);
const EVENT_NAME: array[TMouseEvent] of String = ('MouseDown', 'MouseUp');
var  S: String;
begin
  if ListView1.SelCount < 2 then exit;
  if ListView1.Selected = nil then
    S := '  NOT OK:  Selected is NIL  ... but SelCount is: ' + IntToStr(ListView1.SelCount)  + '    Selected: ' +  ListView1.Selected.Caption
  else
    S := '  FINE!    Selected is NOT Nil;     SelCount is: ' + IntToStr(ListView1.SelCount) + '    Selected: ' + ListView1.Selected.Caption;

  Memo1.Lines.Add(Format('%s: %s', [EVENT_NAME[MouseEvent], S]));
end;



end.

